package org.teiid.byteman;

import org.teiid.translator.jdbc.TranslatedCommand;
import org.teiid.translator.ExecutionContext;
import org.teiid.language.*;

import org.teiid.core.util.StringUtil;

import java.util.*;

import org.jboss.byteman.rule.Rule;  
import org.jboss.byteman.rule.helper.Helper;  


public class BytemanHelperForTranslator extends Helper {  
    protected BytemanHelperForTranslator(Rule rule) {  
        super(rule);  
    }  
    
    public void printToString(Object obj) {  
        debug("vvvvvvvvvvvvvvvvvvvvvvvvvvv"); 
        debug(String.format( "\nToString %s: %s", obj.getClass().getName(), obj.toString()));
        debug("^^^^^^^^^^^^^^^^^^^^^^^^^^^");  
    }   
    
    public void printCount(Object obj) {  
        debug("vvvvvvvvvvvvvvvvvvvvvvvvvvv"); 
        
        if (obj == null) {
            debug(String.format( "\nCount %s: %s", obj.getClass().getName(), "is null"));
            
        } else if (obj.getClass().isArray()) {
            Object[] objList = (Object[]) obj;
			debug(String.format( "\nCount %s: %s", obj.getClass().getName(), objList.length));
            
		} else if (obj instanceof Collection) {
                Collection c = (Collection) obj;
                debug(String.format( "\nCount %s: %s", obj.getClass().getName(), c.size()));
            
		} else	if (obj instanceof Map) {
            Map m = (Map) obj;
            debug(String.format( "\nCount %s: %s", obj.getClass().getName(), m.size()));
		} else {
            debug(String.format( "\nCount for class is not supported %s", obj.getClass().getName()));
        }
        
        debug("^^^^^^^^^^^^^^^^^^^^^^^^^^^");  
    }       
    
    public void printPayLoad(Object obj) {  
        ExecutionContext executionContext = (ExecutionContext) obj;  
        
        StringBuilder builder = new StringBuilder();
        
        Object payload = executionContext.getExecutionPayload();
        if (payload != null) {
            builder.append(String.format( "\nPayload %s: %s", payload.getClass().getName(), payload.toString()));

        } else {
            builder.append("No Payload");
        }
        debug("vvvvvvvvvvvvvvvvvvvvvvvvvvv");  
        debug(builder.toString());
        debug("^^^^^^^^^^^^^^^^^^^^^^^^^^^");  
    }     
}  


